Index: TXM/trunk/org.txm.libs.cqp/src/org/txm/libs/cqp/CQPLibPreferences.java
===================================================================
--- TXM/trunk/org.txm.libs.cqp/src/org/txm/libs/cqp/CQPLibPreferences.java	(revision 3627)
+++ TXM/trunk/org.txm.libs.cqp/src/org/txm/libs/cqp/CQPLibPreferences.java	(revision 3628)
@@ -51,6 +51,7 @@
 	/** The Constant CQI_SERVER_MODE. */
 	public static final String CQI_NETWORK_MODE = "cqi_server_mode"; //$NON-NLS-1$
 	
+	public static String QUERY_FIX_TOKENIZE = "query_fix_tokenize_string"; //$NON-NLS-1$
 	
 	@Override
 	public void initializeDefaultPreferences() {
@@ -145,7 +146,8 @@
 		preferences.put(CQI_SERVER_LOGIN, "anonymous"); //$NON-NLS-1$
 		preferences.put(CQI_SERVER_PASSWORD, ""); //$NON-NLS-1$
 		preferences.putBoolean(CQI_SERVER_IS_REMOTE, false);
-		preferences.putBoolean(CQI_NETWORK_MODE, false); // $NON-NLS-1$
+		preferences.putBoolean(CQI_NETWORK_MODE, false);
+		preferences.putBoolean(QUERY_FIX_TOKENIZE, true);
 		
 		if (saved != null && saved.length() > 0) {
 			Version savedVersion = new Version(saved);

Index: TXM/trunk/org.txm.oriflamms.rcp/META-INF/MANIFEST.MF
===================================================================
--- TXM/trunk/org.txm.oriflamms.rcp/META-INF/MANIFEST.MF	(revision 3627)
+++ TXM/trunk/org.txm.oriflamms.rcp/META-INF/MANIFEST.MF	(revision 3628)
@@ -10,7 +10,7 @@
 Bundle-ActivationPolicy: lazy
 Bundle-ManifestVersion: 2
 Bundle-Activator: oriflamms.Activator
-Bundle-RequiredExecutionEnvironment: JavaSE-1.8
+Bundle-RequiredExecutionEnvironment: JavaSE-16
 Bundle-Vendor: Textometrie.org
 Automatic-Module-Name: org.txm.oriflamms.rcp
 

Index: TXM/trunk/org.txm.treesearch.core/META-INF/MANIFEST.MF
===================================================================
--- TXM/trunk/org.txm.treesearch.core/META-INF/MANIFEST.MF	(revision 3627)
+++ TXM/trunk/org.txm.treesearch.core/META-INF/MANIFEST.MF	(revision 3628)
@@ -4,8 +4,8 @@
 Bundle-SymbolicName: org.txm.treesearch.core;singleton:=true
 Bundle-Version: 1.0.0.qualifier
 Automatic-Module-Name: org.txm.treesearch.rcp
-Bundle-RequiredExecutionEnvironment: JavaSE-1.8
+Bundle-RequiredExecutionEnvironment: JavaSE-16
 Export-Package: org.txm.treesearch.function,
  org.txm.treesearch.preferences
-Require-Bundle: org.txm.core;bundle-version="0.8.2";visibility:=reexport,
+Require-Bundle: org.txm.core;bundle-version="0.8.3";visibility:=reexport,
  org.txm.searchengine.cqp.core;bundle-version="1.1.0";visibility:=reexport

Index: TXM/trunk/org.txm.properties.rcp/META-INF/MANIFEST.MF
===================================================================
--- TXM/trunk/org.txm.properties.rcp/META-INF/MANIFEST.MF	(revision 3627)
+++ TXM/trunk/org.txm.properties.rcp/META-INF/MANIFEST.MF	(revision 3628)
@@ -8,10 +8,10 @@
  org.txm.properties.rcp.preferences
 Bundle-Version: 1.0.0.qualifier
 Bundle-Name: %Bundle-Name
-Require-Bundle: org.txm.rcp;bundle-version="0.8.0";visibility:=reexpor
+Require-Bundle: org.txm.rcp;bundle-version="0.8.3";visibility:=reexpor
  t,org.txm.properties.core;bundle-version="1.0.0";visibility:=reexport
 Bundle-ManifestVersion: 2
-Bundle-RequiredExecutionEnvironment: JavaSE-1.8
+Bundle-RequiredExecutionEnvironment: JavaSE-16
 Bundle-Vendor: Textometrie.org
 Automatic-Module-Name: org.txm.properties.rcp
 

Index: TXM/trunk/org.txm.perl.rcp/META-INF/MANIFEST.MF
===================================================================
--- TXM/trunk/org.txm.perl.rcp/META-INF/MANIFEST.MF	(revision 3627)
+++ TXM/trunk/org.txm.perl.rcp/META-INF/MANIFEST.MF	(revision 3628)
@@ -5,7 +5,7 @@
 Bundle-Version: 1.0.0.qualifier
 Bundle-Vendor: textometrie.org
 Automatic-Module-Name: org.txm.perl.rcp
-Bundle-RequiredExecutionEnvironment: JavaSE-1.8
-Require-Bundle: org.txm.rcp;bundle-version="0.8.2",
+Bundle-RequiredExecutionEnvironment: JavaSE-16
+Require-Bundle: org.txm.rcp;bundle-version="0.8.3",
  org.txm.perl.core;bundle-version="1.0.0"
 Export-Package: org.txm.perl.rcp.preferences

Index: TXM/trunk/org.txm.tests.rcp/META-INF/MANIFEST.MF
===================================================================
--- TXM/trunk/org.txm.tests.rcp/META-INF/MANIFEST.MF	(revision 3627)
+++ TXM/trunk/org.txm.tests.rcp/META-INF/MANIFEST.MF	(revision 3628)
@@ -3,9 +3,16 @@
 Bundle-SymbolicName: org.txm.tests.rcp;singleton:=true
 Bundle-Name: Tests
 Bundle-Version: 1.0.0.qualifier
-Require-Bundle: org.txm.rcp;bundle-version="0.8.0";visibility:=reexpor
- t,org.txm.tests.core;bundle-version="1.0.0";visibility:=reexport
+Require-Bundle: org.txm.rcp;bundle-version="0.8.3";visibility:=reexport,
+ org.txm.tests.core;bundle-version="1.0.0";visibility:=reexport,
+ org.polarion.eclipse.team.svn.connector;bundle-version="6.0.4",
+ org.eclipse.team.svn;bundle-version="4.0.5",
+ org.eclipse.team.svn.ui;bundle-version="4.0.5",
+ org.polarion.eclipse.team.svn.connector.javahl18;bundle-version="6.0.0",
+ org.polarion.eclipse.team.svn.connector.javahl19;bundle-version="6.0.0",
+ org.polarion.eclipse.team.svn.connector.svnkit18;bundle-version="6.0.4",
+ org.txm.svn.rcp;bundle-version="1.0.0"
 Bundle-ManifestVersion: 2
-Bundle-RequiredExecutionEnvironment: JavaSE-1.8
+Bundle-RequiredExecutionEnvironment: JavaSE-16
 Bundle-Vendor: Textometrie.org
 
Index: TXM/trunk/org.txm.tests.rcp/src/org/txm/tests/rcp/command/TestImports.java
===================================================================
--- TXM/trunk/org.txm.tests.rcp/src/org/txm/tests/rcp/command/TestImports.java	(revision 0)
+++ TXM/trunk/org.txm.tests.rcp/src/org/txm/tests/rcp/command/TestImports.java	(revision 3628)
@@ -0,0 +1,219 @@
+// Copyright © 2010-2020 ENS de Lyon., University of Franche-Comté
+// Copyright © 2007-2010 ENS de Lyon, CNRS, INRP, University of
+// Lyon 2, University of Franche-Comté, University of Nice
+// Sophia Antipolis, University of Paris 3.
+// 
+// The TXM platform is free software: you can redistribute it
+// and/or modify it under the terms of the GNU General Public
+// License as published by the Free Software Foundation,
+// either version 2 of the License, or (at your option) any
+// later version.
+// 
+// The TXM platform is distributed in the hope that it will be
+// useful, but WITHOUT ANY WARRANTY; without even the implied
+// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+// PURPOSE. See the GNU General Public License for more
+// details.
+// 
+// You should have received a copy of the GNU General
+// Public License along with the TXM platform. If not, see
+// http://www.gnu.org/licenses.
+// 
+// 
+// 
+// $LastChangedDate:$
+// $LastChangedRevision:$
+// $LastChangedBy:$ 
+//
+package org.txm.tests.rcp.command;
+
+import java.io.File;
+import java.io.IOException;
+import java.util.ArrayList;
+import java.util.HashMap;
+
+import org.eclipse.core.commands.AbstractHandler;
+import org.eclipse.core.commands.ExecutionEvent;
+import org.eclipse.core.commands.ExecutionException;
+import org.eclipse.core.runtime.IProgressMonitor;
+import org.eclipse.core.runtime.IStatus;
+import org.eclipse.core.runtime.Status;
+import org.eclipse.swt.SWT;
+import org.eclipse.swt.widgets.DirectoryDialog;
+import org.eclipse.swt.widgets.Shell;
+import org.eclipse.ui.handlers.HandlerUtil;
+import org.txm.Toolbox;
+import org.txm.objects.Project;
+import org.txm.rcp.JobsTimer;
+import org.txm.rcp.handlers.scripts.ExecuteImportScript;
+import org.txm.rcp.swt.dialog.LastOpened;
+import org.txm.rcp.utils.JobHandler;
+import org.txm.utils.zip.Zip;
+
+public class TestImports extends AbstractHandler {
+
+	public static String ID = "org.txm.rcp.commands.tests.TestImports";
+
+	static HashMap<String, String> scripts = new HashMap<String, String>();
+	static {
+		scripts.clear();
+		scripts.put("cnr", "discoursLoader.groovy"); // cnr +csv
+		scripts.put("hyperbase", "hyperbaseLoader.groovy"); // old hyperbase
+		scripts.put("alceste", "alcesteLoader.groovy"); // alceste
+		scripts.put("alceste2", "alcesteLoader.groovy"); // alceste
+		scripts.put("bfm", "bfmLoader.groovy"); // xml-tei-bfm
+		scripts.put("frantext", "frantextLoader.groovy"); // xml-tei-bfm
+		scripts.put("xml", "xmlLoader.groovy"); // xml
+		scripts.put("factiva", "factivaLoader.groovy"); // factiva
+		scripts.put("xml", "xmlLoader.groovy"); // <w attr="" atrt2="">
+		scripts.put("xmlws", "xmlLoader.groovy"); // <w attr="" atrt2="">
+		scripts.put("txt", "txtLoader.groovy"); // txt + csv
+		scripts.put("transcriber", "transcriberLoader.groovy"); // echant EVS +
+																// csv
+		scripts.put("xmltxm", "xmltxmLoader.groovy"); // domi
+	}
+
+	/*
+	 * (non-Javadoc)
+	 * 
+	 * @see
+	 * org.eclipse.core.commands.AbstractHandler#execute(org.eclipse.core.commands
+	 * .ExecutionEvent)
+	 */
+	@Override
+	public Object execute(ExecutionEvent event) throws ExecutionException {
+		String txmhome = Toolbox.getTxmHomePath();
+		final File scriptsdir = new File(txmhome, "scripts/import");
+		// final File sourcesdir = new
+		// File(System.getProperty("user.home"),"xml/TESTS");
+		final int delta = 100 / scripts.size();
+
+		System.out
+				.println("Please select the directory containing source directories for the following import modules :");
+		System.out.println(scripts.toString());
+
+		Shell shell = HandlerUtil.getActiveWorkbenchWindowChecked(event)
+				.getShell();
+		DirectoryDialog dialog = new DirectoryDialog(shell, SWT.OPEN);
+
+		if (LastOpened.getFile(ID) != null) {
+			dialog.setFilterPath(LastOpened.getFolder(ID));
+		} else {
+			dialog.setFilterPath(System.getProperty("user.home"));
+		}
+		String path = dialog.open();
+
+		if (path == null)
+			return null;
+
+		final File sourcesdir = new File(path);
+
+		if (!scriptsdir.exists()) {
+			System.out.println("Error: TXM is not well installed.");
+			System.out.println("Cannot find TXM import scripts directory: "
+					+ scriptsdir);
+			return null;
+		}
+
+		if (!sourcesdir.exists()) {
+			System.out.println("Cannot find test sources directory: "
+					+ sourcesdir);
+			return null;
+		}
+
+		System.out
+				.println("Select the directory containing the source directories : "
+						+ scripts.keySet());
+		JobHandler jobhandler = new JobHandler(
+				"Testing TXM - select the directory containing the source dierctories") {
+			@Override
+			protected IStatus run(IProgressMonitor monitor) {
+				this.runInit(monitor);
+				try {
+					String txmhome = Toolbox.getTxmHomePath();
+					File outDir = new File(txmhome, "results/TESTS-imports");
+					outDir.mkdirs();
+					ArrayList<File> missings = new ArrayList<File>();
+					try {
+						monitor.beginTask("Testing imports", 100);
+						JobsTimer.start();
+
+						for (String filename : scripts.keySet()) {
+							final File source = new File(sourcesdir, filename);
+							final File script = new File(scriptsdir,
+									scripts.get(filename));
+
+							if (source.exists()) {
+								
+								Project project = new Project(Toolbox.workspace, "TEST-"+source.getName().substring(0, 3).toUpperCase());
+								project.setSourceDirectory(source.getAbsolutePath());
+								project.setImportModuleName(filename);//$NON-NLS-1$
+								System.out.println("USING ROOT DIR : "
+										+ project.getSrcdir());
+								this.syncExec(new Runnable() {
+									public void run() {
+										
+										try {
+											project.compute();
+											
+											ExecuteImportScript.executeScript(project);
+										} catch (Exception e) {
+											// TODO Auto-generated catch block
+											e.printStackTrace();
+										}
+									}
+								});
+							} else {
+								System.out.println("Warning: Missing source directory: " + source);
+								missings.add(source);
+							}
+							monitor.worked(delta);
+							if (monitor.isCanceled())
+								return Status.CANCEL_STATUS;
+						}
+					} catch (Exception e) {
+						org.txm.utils.logger.Log.printStackTrace(e);
+						return Status.CANCEL_STATUS;
+					}
+
+					String date = Toolbox.dateformat.format(new java.util.Date());
+					File zipFile = new File(outDir.getParentFile(),
+							"TESTS_imports_" + date + ".zip");
+					File zipFile2 = new File(outDir.getParentFile(),
+							"TESTS_imports_.odt");
+					this.acquireSemaphore();
+					zipFile.delete();
+					zipFile2.delete();
+					this.releaseSemaphore();
+					if (missings.size() > 0)
+						System.out.println("Missing sources directories: "
+								+ missings);
+					monitor.beginTask(
+							"Testing imports: results will be compressed in "
+									+ zipFile.getAbsolutePath(), 100);
+					System.out
+							.println("Testing imports: results will be compressed in "
+									+ zipFile.getAbsolutePath());
+					try {
+						this.acquireSemaphore();
+						Zip.compress(outDir, zipFile2);
+						zipFile2.renameTo(zipFile);
+						this.releaseSemaphore();
+					} catch (IOException e) {
+						org.txm.utils.logger.Log.printStackTrace(e);
+						return Status.CANCEL_STATUS;
+					}
+				} catch (ThreadDeath td) {
+					return Status.CANCEL_STATUS;
+				} finally {
+					monitor.done();
+					JobsTimer.stopAndPrint();
+				}
+				return Status.OK_STATUS;
+			}
+		};
+
+		jobhandler.startJob();
+		return null;
+	}
+}

Index: TXM/trunk/org.txm.tests.rcp/src/org/txm/tests/rcp/command/TestImportLangs.java
===================================================================
--- TXM/trunk/org.txm.tests.rcp/src/org/txm/tests/rcp/command/TestImportLangs.java	(revision 0)
+++ TXM/trunk/org.txm.tests.rcp/src/org/txm/tests/rcp/command/TestImportLangs.java	(revision 3628)
@@ -0,0 +1,168 @@
+// Copyright © 2010-2020 ENS de Lyon., University of Franche-Comté
+package org.txm.tests.rcp.command;
+
+import java.io.File;
+import java.io.IOException;
+import java.text.DateFormat;
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.Locale;
+
+import javax.xml.parsers.ParserConfigurationException;
+
+import org.eclipse.core.commands.AbstractHandler;
+import org.eclipse.core.commands.ExecutionEvent;
+import org.eclipse.core.commands.ExecutionException;
+import org.eclipse.core.runtime.IProgressMonitor;
+import org.eclipse.core.runtime.IStatus;
+import org.eclipse.core.runtime.Status;
+import org.eclipse.swt.SWT;
+import org.eclipse.swt.widgets.DirectoryDialog;
+import org.eclipse.swt.widgets.Shell;
+import org.eclipse.ui.handlers.HandlerUtil;
+import org.txm.Toolbox;
+import org.txm.core.preferences.TBXPreferences;
+import org.txm.objects.Project;
+import org.txm.rcp.JobsTimer;
+import org.txm.rcp.handlers.scripts.ExecuteImportScript;
+import org.txm.rcp.utils.JobHandler;
+import org.txm.utils.io.IOUtils;
+import org.xml.sax.SAXException;
+
+public class TestImportLangs extends AbstractHandler {
+
+	public static String ID = "org.txm.rcp.commands.tests.TestImports";
+
+	static HashMap<String, String> scripts = new HashMap<String, String>();
+	static {
+		scripts.clear();
+		scripts.put("xml", "xmlLoader.groovy"); // xml	
+		scripts.put("txt", "txtLoader.groovy"); // txt + csv
+	}
+
+	/*
+	 * (non-Javadoc)
+	 * 
+	 * @see
+	 * org.eclipse.core.commands.AbstractHandler#execute(org.eclipse.core.commands
+	 * .ExecutionEvent)
+	 */
+	@Override
+	public Object execute(ExecutionEvent event) throws ExecutionException {
+		String txmhome = Toolbox.getTxmHomePath();
+		final File scriptsdir = new File(txmhome, "scripts/import");
+
+		System.out.println("Select the directory containing the source directories : "
+				+ scripts.keySet());
+		JobHandler jobhandler = new JobHandler(
+				"Testing TXM - langs") {
+			@Override
+			protected IStatus run(IProgressMonitor monitor) {
+				this.runInit(monitor);
+				try {
+					try {
+						final File sourcesdir = new File("/tmp/test-langs");
+						sourcesdir.mkdirs();
+
+						if (!scriptsdir.exists()) {
+							System.out.println("Error: TXM is not well installed.");
+							System.out.println("Cannot find TXM import scripts directory: "
+									+ scriptsdir);
+							return null;
+						}
+
+						if (!sourcesdir.exists()) {
+							System.out.println("Cannot find test sources directory: "
+									+ sourcesdir);
+							return null;
+						}
+
+						monitor.beginTask("Testing imports", 100);
+						JobsTimer.start();
+
+						importXMLCorpus(this, sourcesdir, scriptsdir);
+						importTXTCorpus(this, sourcesdir, scriptsdir);
+
+					} catch (Exception e) {
+						org.txm.utils.logger.Log.printStackTrace(e);
+						return Status.CANCEL_STATUS;
+					}
+
+				} catch (ThreadDeath td) {
+					return Status.CANCEL_STATUS;
+				} finally {
+					monitor.done();
+					JobsTimer.stopAndPrint();
+				}
+				return Status.OK_STATUS;
+			}
+
+
+		};
+
+		jobhandler.startJob();
+		return null;
+	}
+
+	protected boolean importXMLCorpus(JobHandler jobhandler, File sourcesdir, File scriptsdir) throws Exception {
+		final File source = new File(sourcesdir, "XMLLANGTEST");
+		source.mkdirs();
+		File oneTextFile = new File(source, "file.xml");
+		IOUtils.write(oneTextFile, "<text>This corpus works fine. That's all.</text>");
+		final File script = new File(scriptsdir, scripts.get("xml"));
+
+		final Project project = new Project(Toolbox.workspace, "TESTXML");
+		project.setSourceDirectory(source.getAbsolutePath());
+		project.setLang("en");
+		project.setAnnotate(true); //$NON-NLS-1$
+		project.setImportModuleName("xml");//$NON-NLS-1$
+		project.compute();
+
+		System.out.println("USING ROOT DIR : "+ project.getSrcdir());
+		jobhandler.syncExec(new Runnable() {
+			public void run() {
+				new ExecuteImportScript();
+				JobHandler job = ExecuteImportScript
+						.executeScript(project);
+				try {
+					job.join();
+				} catch (InterruptedException e) {
+					// TODO Auto-generated catch block
+					e.printStackTrace();
+				}
+			}
+		});
+		return true;	}
+
+	protected boolean importTXTCorpus(JobHandler jobhandler, File sourcesdir, File scriptsdir) throws Exception {
+		final File source = new File(sourcesdir, "TXTLANGTEST");
+		source.mkdirs();
+		File oneTextFile = new File(source, "file.txt");
+		IOUtils.write(oneTextFile, "<text>C'est !C'est encore une phrase qui ne s'tokenize pas bien. Mais c'est pas drave.");
+		
+		final File script = new File(scriptsdir, scripts.get("txt"));
+
+		final Project project = new Project(Toolbox.workspace, "TESTTXT");
+		project.setSourceDirectory(source.getAbsolutePath());
+		project.setLang("fr");
+		project.setAnnotate(true); //$NON-NLS-1$
+		project.setImportModuleName("txt");//$NON-NLS-1$
+		project.compute();
+		
+		System.out.println("USING ROOT DIR : "+ project.getSrcdir());
+		jobhandler.syncExec(new Runnable() {
+			public void run() {
+				new ExecuteImportScript();
+				JobHandler job = ExecuteImportScript
+						.executeScript(project);
+				try {
+					job.join();
+				} catch (InterruptedException e) {
+					// TODO Auto-generated catch block
+					e.printStackTrace();
+				}
+			}
+		});
+		return true;
+	}
+}

Index: TXM/trunk/org.txm.tests.rcp/src/org/txm/tests/rcp/editor/TestsEditor.java
===================================================================
--- TXM/trunk/org.txm.tests.rcp/src/org/txm/tests/rcp/editor/TestsEditor.java	(revision 3627)
+++ TXM/trunk/org.txm.tests.rcp/src/org/txm/tests/rcp/editor/TestsEditor.java	(revision 3628)
@@ -22,9 +22,9 @@
 import org.eclipse.ui.part.EditorPart;
 import org.txm.Toolbox;
 import org.txm.rcp.IImageKeys;
-import org.txm.rcp.commands.tests.Test;
-import org.txm.rcp.commands.tests.TestBench;
 import org.txm.rcp.handlers.files.EditFile;
+import org.txm.scripts.macro.tests.Test;
+import org.txm.scripts.macro.tests.TestBench;
 
 public class TestsEditor extends EditorPart {
 
Index: TXM/trunk/org.txm.tests.rcp/src/org/txm/scripts/macro/tests/ResetAllTestsMacro.groovy
===================================================================
--- TXM/trunk/org.txm.tests.rcp/src/org/txm/scripts/macro/tests/ResetAllTestsMacro.groovy	(revision 0)
+++ TXM/trunk/org.txm.tests.rcp/src/org/txm/scripts/macro/tests/ResetAllTestsMacro.groovy	(revision 3628)
@@ -0,0 +1,22 @@
+package org.txm.scripts.macro.tests
+
+import java.io.File
+import org.kohsuke.args4j.*
+import groovy.transform.Field
+import org.txm.rcp.swt.widget.parameters.*
+import org.txm.Toolbox
+import org.txm.rcp.commands.tests.*
+
+@Field @Option(name="step", usage="step to execute, 0=all 1=export&test 2=test", widget="Integer", required=true, def="0")
+int step
+
+// Open the parameters input dialog box
+if (!ParametersDialog.open(this)) return;
+
+if (step < 0) step = 0;
+if (step > 3) step = 2;
+
+TestBench bench = GroovyTestBench.getTests();
+for (Test test : bench.getTests().values()) {
+	test.reset();
+}
\ No newline at end of file
Index: TXM/trunk/org.txm.tests.rcp/src/org/txm/scripts/macro/tests/RunAllTestsMacro.groovy
===================================================================
--- TXM/trunk/org.txm.tests.rcp/src/org/txm/scripts/macro/tests/RunAllTestsMacro.groovy	(revision 0)
+++ TXM/trunk/org.txm.tests.rcp/src/org/txm/scripts/macro/tests/RunAllTestsMacro.groovy	(revision 3628)
@@ -0,0 +1,27 @@
+package org.txm.scripts.macro.tests
+
+import java.io.File
+import org.kohsuke.args4j.*
+import groovy.transform.Field
+import org.txm.rcp.swt.widget.parameters.*
+import org.txm.Toolbox
+import org.txm.rcp.commands.tests.*
+
+@Field @Option(name="step", usage="step to execute, 0=all 1=export&test 2=test", widget="Integer", required=true, def="0")
+int step
+
+// Open the parameters input dialog box
+if (!ParametersDialog.open(this)) return;
+
+if (step < 0) step = 0;
+if (step > 3) step = 2;
+
+TestBench bench = GroovyTestBench.getTests();
+for (Test test : bench.getTests().values()) {
+	String name = test.getName()
+	if (test.run(step)) {
+		println "$name -> OK"
+	} else {
+		println "$name -> KO"
+	}
+}
\ No newline at end of file
Index: TXM/trunk/org.txm.tests.rcp/src/org/txm/scripts/macro/tests/DeleteTestMacro.groovy
===================================================================
--- TXM/trunk/org.txm.tests.rcp/src/org/txm/scripts/macro/tests/DeleteTestMacro.groovy	(revision 0)
+++ TXM/trunk/org.txm.tests.rcp/src/org/txm/scripts/macro/tests/DeleteTestMacro.groovy	(revision 3628)
@@ -0,0 +1,23 @@
+package org.txm.scripts.macro.tests
+
+import java.io.File
+import org.kohsuke.args4j.*
+import groovy.transform.Field
+import org.txm.rcp.swt.widget.parameters.*
+import org.txm.Toolbox
+import org.txm.rcp.commands.tests.*
+
+@Field @Option(name="name", usage="The test name to delete", widget="String", required=true, def="test1")
+String name
+
+// Open the parameters input dialog box
+if (!ParametersDialog.open(this)) return;
+
+TestBench bench = GroovyTestBench.getTests();
+Test test = bench.getTest(name)
+
+if (test != null) {
+	bench.deleteTest(test.getName())
+} else {
+	println "No test with name=$name to delete."
+}
\ No newline at end of file
Index: TXM/trunk/org.txm.tests.rcp/src/org/txm/scripts/macro/tests/GroovyTestBench.groovy
===================================================================
--- TXM/trunk/org.txm.tests.rcp/src/org/txm/scripts/macro/tests/GroovyTestBench.groovy	(revision 0)
+++ TXM/trunk/org.txm.tests.rcp/src/org/txm/scripts/macro/tests/GroovyTestBench.groovy	(revision 3628)
@@ -0,0 +1,24 @@
+package org.txm.scripts.macro.tests
+
+import org.txm.Toolbox
+
+/**
+ * Stores the Tests results
+ * 
+ * @author mdecorde
+ *
+ */
+public class GroovyTestBench {
+	
+	private static TestBench bench = null;
+	
+	public TestBench getTests() {
+		if (bench != null) return bench;
+		
+		File dir = new File(Toolbox.getTxmHomePath(), "scripts/groovy/user/org/txm/scripts/tests");
+		dir.mkdirs();
+		bench = new TestBench(dir);
+		
+		return bench;
+	}
+}
Index: TXM/trunk/org.txm.tests.rcp/src/org/txm/scripts/macro/tests/RunTestMacro.groovy
===================================================================
--- TXM/trunk/org.txm.tests.rcp/src/org/txm/scripts/macro/tests/RunTestMacro.groovy	(revision 0)
+++ TXM/trunk/org.txm.tests.rcp/src/org/txm/scripts/macro/tests/RunTestMacro.groovy	(revision 3628)
@@ -0,0 +1,29 @@
+package org.txm.scripts.macro.tests
+
+import java.io.File
+import org.kohsuke.args4j.*
+import groovy.transform.Field
+import org.txm.rcp.swt.widget.parameters.*
+import org.txm.Toolbox
+import org.txm.rcp.commands.tests.*
+
+@Field @Option(name="name", usage="The test name to run", widget="String", required=true, def="test1")
+String name
+
+@Field @Option(name="step", usage="step to execute, 0=all 1=export&test 2=test", widget="Integer", required=true, def="0")
+int step
+
+// Open the parameters input dialog box
+if (!ParametersDialog.open(this)) return;
+
+if (step < 0) step = 0;
+if (step > 3) step = 2;
+
+TestBench bench = GroovyTestBench.getTests();
+Test test = bench.getTest(name)
+
+if (test.run(step)) {
+	println "$name -> OK see "+test.getLogs()
+} else {
+	println "$name -> KO see "+test.getLogs()
+}
\ No newline at end of file
Index: TXM/trunk/org.txm.tests.rcp/src/org/txm/scripts/macro/tests/WriteQualifierInBuildPropertiesFromSVN.java
===================================================================
--- TXM/trunk/org.txm.tests.rcp/src/org/txm/scripts/macro/tests/WriteQualifierInBuildPropertiesFromSVN.java	(revision 0)
+++ TXM/trunk/org.txm.tests.rcp/src/org/txm/scripts/macro/tests/WriteQualifierInBuildPropertiesFromSVN.java	(revision 3628)
@@ -0,0 +1,138 @@
+package org.txm.scripts.macro.tests;
+
+import java.io.File;
+import java.io.FileFilter;
+import java.io.FileOutputStream;
+import java.text.SimpleDateFormat;
+import java.util.ArrayList;
+import java.util.Arrays;
+import java.util.Collections;
+import java.util.Properties;
+
+import org.tmatesoft.svn.core.SVNDirEntry;
+import org.tmatesoft.svn.core.SVNURL;
+import org.tmatesoft.svn.core.io.SVNRepository;
+import org.tmatesoft.svn.core.io.SVNRepositoryFactory;
+import org.tmatesoft.svn.core.wc.SVNClientManager;
+import org.tmatesoft.svn.core.wc.SVNInfo;
+import org.tmatesoft.svn.core.wc.SVNRevision;
+import org.tmatesoft.svn.core.wc.SVNWCClient;
+import org.txm.utils.io.IOUtils;
+
+/**
+ * Write the qualifier in build.properties of all plugins from the SVN revision.
+ * @author sjacquot
+ *
+ */
+public class WriteQualifierInBuildPropertiesFromSVN {
+
+	public static File workspace = new File("../"); // SJ
+
+	public static int updatedFilesCount = 0;
+	
+	/**
+	 * fetch  the org.txm projects that ends with core or rcp
+	 * @return
+	 */
+	protected static ArrayList<File> getProjects() {
+		ArrayList<File> ret = new ArrayList<File>();
+		if (!workspace.exists()) {
+			System.err.println("ERROR: "+workspace+" does not exists. Set it in TXMPluginTest.java.");
+			return ret;
+		} 
+
+		ret.addAll(Arrays.asList(workspace.listFiles(new FileFilter() {
+			@Override
+			public boolean accept(File pathName) {
+				return pathName.isDirectory() &&
+						(pathName.getName().endsWith(".rcp")
+								|| pathName.getName().endsWith(".core")
+								|| pathName.getName().endsWith(".feature")
+								);
+			}
+		})));
+
+		Collections.sort(ret);
+		return ret;
+	}
+	
+	public static void main(String[] args) {
+		ArrayList<File> projectsList = getProjects();
+		for (int i = 0; i < projectsList.size(); i++) {
+			writeQualifierInBuildProperties(projectsList.get(i));
+		}
+		
+		System.out.println("Done. " + updatedFilesCount + " build.properties files have been updated.");
+	}
+
+	
+	
+	public static void writeQualifierInBuildProperties(File projectDirectory) {
+
+		try {
+			SVNWCClient client = SVNClientManager.newInstance().getWCClient();
+			SVNInfo info = client.doInfo(projectDirectory, SVNRevision.WORKING);
+			SVNURL location = info.getURL();
+			SVNRepository repository = SVNRepositoryFactory.create(location);
+			
+//			long latestRevision = repository.getLatestRevision();
+//			System.out.println("[" + location.toString() + "] latest revision: " + latestRevision); 
+
+
+			SVNDirEntry entry = repository.info(".", -1);
+//			System.out.println("[" + location.toString() + "] latest revision: " + entry.getRevision());
+//			System.out.println("[" + location.toString() + "] latest date: " + entry.getDate());
+			
+			SimpleDateFormat formatter = new SimpleDateFormat("yyyyMMdd-HHmm");
+			//SimpleDateFormat formatter = new SimpleDateFormat("yyyyMMddHHmm");
+			String date = formatter.format(entry.getDate());
+			System.out.println("[" + location.toString() + " / " + projectDirectory + "] latest date: " + date);
+//			System.err.println("formatted date: " + format);
+			
+//			SvnOperationFactory operationFactory = new SvnOperationFactory();
+//			SvnLog logOperation = operationFactory.createLog();
+//			logOperation.setSingleTarget(SvnTarget.fromFile( projectDirectory )			);
+//			logOperation.setRevisionRanges( Collections.singleton(
+//			        SvnRevisionRange.create(
+//			                SVNRevision.create( 1 ),
+//			                SVNRevision.HEAD
+//			        )
+//			) );
+//			Collection<SVNLogEntry> logEntries = logOperation.run( null );
+//			System.out.println( "logEntries = " + logEntries );
+			
+			
+			File buildFile = new File(projectDirectory, "build.properties");
+			
+			if (!buildFile.exists()) {
+				System.err.println("No build.properties file in: " + projectDirectory);
+				return;
+			}
+			
+			Properties props = new Properties();
+			props.load(IOUtils.getReader(buildFile));
+
+			// Debug: deleting all qualifiers
+//			props.remove("qualifier");
+//			props.store(new FileOutputStream(buildFile), null);
+			
+			// Write qualifier
+			String oldDate = props.getProperty("qualifier");
+			if(oldDate == null || !oldDate.equals(date))	{
+				
+				if(oldDate == null)	{
+					oldDate = "none";
+				}
+				
+				updatedFilesCount++;
+				System.out.println("Setting qualifier from " + oldDate + " to " + date);
+				props.setProperty("qualifier", date);
+				props.store(new FileOutputStream(buildFile), null);
+			}
+		}
+		catch (Exception e) {
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		}
+	}
+}
\ No newline at end of file

Index: TXM/trunk/org.txm.tests.rcp/src/org/txm/scripts/macro/tests/NewTestMacro.groovy
===================================================================
--- TXM/trunk/org.txm.tests.rcp/src/org/txm/scripts/macro/tests/NewTestMacro.groovy	(revision 0)
+++ TXM/trunk/org.txm.tests.rcp/src/org/txm/scripts/macro/tests/NewTestMacro.groovy	(revision 3628)
@@ -0,0 +1,23 @@
+package org.txm.scripts.macro.tests
+
+import java.io.File
+import org.kohsuke.args4j.*
+import groovy.transform.Field
+import org.txm.rcp.swt.widget.parameters.*
+import org.txm.Toolbox
+import org.txm.rcp.commands.tests.*
+
+@Field @Option(name="name", usage="The test name to create", widget="String", required=true, def="test1")
+String name
+
+// Open the parameters input dialog box
+if (!ParametersDialog.open(this)) return;
+
+TestBench bench = GroovyTestBench.getTests();
+Test test = bench.getTest(name)
+
+if (test != null) {
+	println "Already created."
+} else {
+	bench.newTest(name)
+}
\ No newline at end of file
